#line 1 "C:/Users/martin/Documents/proteus/Voltmeter_serial/voltmeter_serial.c"


sbit LCD_RS at RB2_bit;
sbit LCD_EN at RB3_bit;
sbit LCD_D4 at RB4_bit;
sbit LCD_D5 at RB5_bit;
sbit LCD_D6 at RB6_bit;
sbit LCD_D7 at RB7_bit;

sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;


unsigned int Radc = 0;
unsigned int vcc = 0;
char *VDD = "000.0";
char Text[15];
char text1[] = "VOLTAGE:";
float voltage = 0.0;

void volt(){
if(vcc < 10000){
 VDD[0] = ' ';
 VDD[1] = (vcc/1000)%10 + 48;
 VDD[2] = (vcc/100)%10 + 48;
 VDD[4] = (vcc/10)%10 + 48;
 Lcd_Out(2,4,VDD);
 UART1_Write_Text(VDD);
 UART1_Write(0x0D);
 UART1_Write(0x0A);
 Delay_ms(20);
 } else{
 VDD[0] = (vcc/10000)%10 + 48;
 VDD[1] = (vcc/1000)%10 + 48;
 VDD[2] = (vcc/100)%10 + 48;
 VDD[4] = (vcc/10)%10 + 48;
 Lcd_Out(2,4,VDD);
 UART1_Write_Text(VDD);
 UART1_Write(0x0D);
 UART1_Write(0x0A);
 Delay_ms(20);
 }


}

void set_up() {
 ANSEL = 0x04;
 TRISA = 0x04;
 ADCON1 = 0x82;
 ANSELH = 0;
 C1ON_bit = 0;
 C2ON_bit = 0;

 ADC_Init();
 UART1_Init(9600);
 Delay_ms(100);
 LCD_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,4,text1);
 Lcd_Chr(2,9,'v');
 Delay_ms(100);
}

 void main() {
 set_up();
while(1){
 Radc = ADC_Get_Sample(2);
 voltage = (float)(Radc * 0.05);
 vcc = (voltage*100);
 FloatToStr(voltage,Text);
 volt();
 Delay_ms(600);

 }
}
